
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class WarehousesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const warehouses = await db.warehouses.create(
            {
                id: data.id || undefined,
        
        warehouse_name: data.warehouse_name
        ||
        null
            ,
            
        code: data.code
        ||
        null
            ,
            
        contact_name: data.contact_name
        ||
        null
            ,
            
        contact_phone: data.contact_phone
        ||
        null
            ,
            
        address: data.address
        ||
        null
            ,
            
        is_default: data.is_default
        ||
        false
        
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await warehouses.setTenant( data.tenant || null, {
            transaction,
        });
        
        await warehouses.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return warehouses;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const warehousesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                warehouse_name: item.warehouse_name
            ||
            null
            ,
            
                code: item.code
            ||
            null
            ,
            
                contact_name: item.contact_name
            ||
            null
            ,
            
                contact_phone: item.contact_phone
            ||
            null
            ,
            
                address: item.address
            ||
            null
            ,
            
                is_default: item.is_default
            ||
            false
        
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const warehouses = await db.warehouses.bulkCreate(warehousesData, { transaction });

        // For each item created, replace relation files
        

        return warehouses;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const warehouses = await db.warehouses.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.warehouse_name !== undefined) updatePayload.warehouse_name = data.warehouse_name;
        
        
        if (data.code !== undefined) updatePayload.code = data.code;
        
        
        if (data.contact_name !== undefined) updatePayload.contact_name = data.contact_name;
        
        
        if (data.contact_phone !== undefined) updatePayload.contact_phone = data.contact_phone;
        
        
        if (data.address !== undefined) updatePayload.address = data.address;
        
        
        if (data.is_default !== undefined) updatePayload.is_default = data.is_default;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await warehouses.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await warehouses.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await warehouses.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return warehouses;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const warehouses = await db.warehouses.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of warehouses) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of warehouses) {
                await record.destroy({transaction});
            }
        });


        return warehouses;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const warehouses = await db.warehouses.findByPk(id, options);

        await warehouses.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await warehouses.destroy({
            transaction
        });

        return warehouses;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const warehouses = await db.warehouses.findOne(
            { where },
            { transaction },
        );

        if (!warehouses) {
            return warehouses;
        }

        const output = warehouses.get({plain: true});

        
        
        
        
        
        
        
        
        output.inventory_items_warehouse = await warehouses.getInventory_items_warehouse({
            transaction
        });
        
        
        output.inventory_movements_warehouse = await warehouses.getInventory_movements_warehouse({
            transaction
        });
        
        
        
        output.orders_warehouse = await warehouses.getOrders_warehouse({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.ai_insights_related_warehouse = await warehouses.getAi_insights_related_warehouse({
            transaction
        });
        
        
        
        
        output.tenant = await warehouses.getTenant({
            transaction
        });
        
        
        output.organizations = await warehouses.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              tenant_name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.warehouse_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'warehouses',
                        'warehouse_name',
                        filter.warehouse_name,
                    ),
                };
            }
            
            if (filter.code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'warehouses',
                        'code',
                        filter.code,
                    ),
                };
            }
            
            if (filter.contact_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'warehouses',
                        'contact_name',
                        filter.contact_name,
                    ),
                };
            }
            
            if (filter.contact_phone) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'warehouses',
                        'contact_phone',
                        filter.contact_phone,
                    ),
                };
            }
            
            if (filter.address) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'warehouses',
                        'address',
                        filter.address,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_default) {
                where = {
                    ...where,
                is_default: filter.is_default,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.warehouses.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'warehouses',
                        'warehouse_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.warehouses.findAll({
            attributes: [ 'id', 'warehouse_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['warehouse_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.warehouse_name,
        }));
    }

    
};

